package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSACTIONMIXPAGES*/
@Entity(name="TgeneTransactionMixPages")
@Table(name="TGENETRANSACTIONMIXPAGES")
public class TgeneTransactionMixPages extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneTransactionMixPages
*/
@EmbeddedId
private TgeneTransactionMixPagesKey pk;
@Column(name="ORIGIN", nullable=true)

/**
* Y Indica que la transaccion sirve para fondeo del efectivo, N resta los fondos 
*/
private String origin;

@Column(name="PRESENTATIONORDER", nullable=true)

/**
* Orden de presentacion
*/
private Integer presentationorder;

/**Contructor por defecto*/
public TgeneTransactionMixPages(){
}
/**Contructor de TgeneTransactionMixPages
@param pPk Clave Primaria del entity
*/
public TgeneTransactionMixPages(TgeneTransactionMixPagesKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneTransactionMixPages
*/
public static TgeneTransactionMixPages find(EntityManager pEntityManager,TgeneTransactionMixPagesKey pKey) throws Exception{
    TgeneTransactionMixPages obj = pEntityManager.find(TgeneTransactionMixPages.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneTransactionMixPages
@return El objeto que referencia a la Clave primaria de TgeneTransactionMixPages
*/
public TgeneTransactionMixPagesKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneTransactionMixPages
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransactionMixPages
*/
public void setPk(TgeneTransactionMixPagesKey pPk){
  pk=pPk;
}
/**Obtiene el valor de origin
@return valor de origin*/
public String getOrigin(){
  return origin;
}
/**Fija el valor de origin
@param pOrigin nuevo Valor de origin*/
public void setOrigin(String pOrigin){
  origin=pOrigin;
}

/**Obtiene el valor de presentationorder
@return valor de presentationorder*/
public Integer getPresentationorder(){
  return presentationorder;
}
/**Fija el valor de presentationorder
@param pPresentationorder nuevo Valor de presentationorder*/
public void setPresentationorder(Integer pPresentationorder){
  presentationorder=pPresentationorder;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneTransactionMixPages))return false;
    TgeneTransactionMixPages that = (TgeneTransactionMixPages) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneTransactionMixPages
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneTransactionMixPages
*/
public Object createInstance(){
 TgeneTransactionMixPages instance=new TgeneTransactionMixPages();	
 instance.setPk(new TgeneTransactionMixPagesKey());
 return instance;
}
/**Clona la entidad TgeneTransactionMixPages
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneTransactionMixPages p=(TgeneTransactionMixPages)this.clone();
  p.setPk((TgeneTransactionMixPagesKey)this.pk.cloneMe());
  return p;
}
}
